#pragma once
#include	"stdThread.h"

#define		MAGIC_DATA_LEN		36
#define		MAGIC_STRING		"E2E6F7BF-42B1-4382-AF0B-1F452ED13EB6"
#define		FILE_NAME_LEN		256			// ★ファイル名の長さ
#define		FILE_SIZE_DIGIT		10			// ★ファイルサイズの桁数

// Client->Server, Server->Client
#define		CMD_MSG_DATA			100
// Client->Server
#define		CMD_SEND_FILE_START_REQ	200		// ★送信開始要求
#define		CMD_SEND_FILE_ING		201		// ★ファイル送信中
#define		CMD_SEND_FILE_END_REQ	202		// ★送信完了要求
#define		CMD_SEND_FILE_ABORT_REQ	203		// ★中断要求

// Server->Client
#define		CMD_SEND_FILE_START_RES	1200	// ★送信開始要求に対する応答
#define		CMD_SEND_FILE_END_RES	1202	// ★送信完了要求に対する応答
#define		CMD_SEND_FILE_ABORT_RES	1203	// ★中断要求に対する応答



#pragma pack(push ,1)
// 共通ヘッダ部
typedef struct
{
	BYTE	bMagicData[MAGIC_DATA_LEN];		// 不正アクセス防止用(WindowsのGUIDを使います)
	WORD	wCommand;						// ネットワークオーダー
	WORD	wDataLen;						// ネットワークオーダー
} HeaderRec;

// メッセージ送信用構造体 共通ヘッダ部 + データ部 
typedef struct
{
	HeaderRec	header;
	BYTE		bMsgData[1];				// nullターミネイトを含まないデータ
} MsgDataRec;

//------------------------------------
// ★データ部 ファイル送信開始要求
typedef struct
{
	char	szFileSize[FILE_SIZE_DIGIT + 1];	// ファイル長文字列(nullターミネートを含む)
	char	szFileName[FILE_NAME_LEN + 1];		// ファイル名文字列(nullターミネートを含む)UTF-8
} FileInfoRec;

typedef struct
{
	HeaderRec	header;
	FileInfoRec	FileInfo;
} SendFileStartReqRec;

//------------------------------------
// ★データ部 ファイル送信(ファイルの途中、最後)
typedef struct
{
	char	szOffset[FILE_SIZE_DIGIT + 1];		// 先頭からの位置
	char	szSize[FILE_SIZE_DIGIT + 1];		// データのサイズ
} SendFileStatRec;

typedef struct
{
	HeaderRec		header;
	SendFileStatRec	Stat;
	BYTE			bData[1];
} SendFileIngRec, SendFileEndReqRec;

//------------------------------------
// ★データ部 ファイル送信中断要求
typedef struct
{
	HeaderRec	header;
} SendFileAbortReqRec;

//------------------------------------
// ★データ部 ファイル送信要求に対する応答
typedef struct
{
	HeaderRec	header;
	char		cResCode;						// 1:成功 -1:失敗 など応答内容コード
} SendFileResRec;

#pragma pack(pop)

